package org.jeecg.modules.stm.rate.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.rate.entity.RateSco;
import org.jeecg.modules.stm.rate.service.IRateScoService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

 
import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: rate_sco
 * @Author: jeecg-boot
 * @Date:   2023-09-26
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/rate/rateSco")
@Slf4j
public class RateScoController extends JeecgController<RateSco, IRateScoService> {
	@Autowired
	private IRateScoService rateScoService;
	
	/**
	 * 分页列表查询
	 *
	 * @param rateSco
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "rate_sco-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<RateSco>> queryPageList(RateSco rateSco,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<RateSco> queryWrapper = QueryGenerator.initQueryWrapper(rateSco, req.getParameterMap());
		Page<RateSco> page = new Page<RateSco>(pageNo, pageSize);
		IPage<RateSco> pageList = rateScoService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param rateSco
	 * @return
	 */
	@AutoLog(value = "rate_sco-添加")
	  
	//@RequiresPermissions("rate:rate_sco:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody RateSco rateSco) {
		rateScoService.save(rateSco);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param rateSco
	 * @return
	 */
	@AutoLog(value = "rate_sco-编辑")
	  
	//@RequiresPermissions("rate:rate_sco:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody RateSco rateSco) {
		rateScoService.updateById(rateSco);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "rate_sco-通过id删除")
	  
	//@RequiresPermissions("rate:rate_sco:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		rateScoService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "rate_sco-批量删除")
	  
	//@RequiresPermissions("rate:rate_sco:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.rateScoService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "rate_sco-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<RateSco> queryById(@RequestParam(name="id",required=true) String id) {
		RateSco rateSco = rateScoService.getById(id);
		if(rateSco==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(rateSco);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param rateSco
    */
   // @RequiresPermissions("rate:rate_sco:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, RateSco rateSco) {
        return super.exportXls(request, rateSco, RateSco.class, "rate_sco");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("rate:rate_sco:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, RateSco.class);
    }

}
